#include "Messages.h"
#include "RPGApp.h"
#include "RPGWindow.h"



//--------------------------------------------------
//	Implementation of the RPGApp class
//--------------------------------------------------

// Constructor
RPGApp::RPGApp(const char *signature) : BApplication(signature)
{
	// Initialize the random number generator
	srand(getpid() * time(NULL) | 1);
}

// Init the app and draw the window
void RPGApp::ReadyToRun()
{
	fUpperCase	=	true;
	fLowerCase	=	true;
	fNumbers	=	true;
	fDigitNb	=	8;
	fPassWdNb	=	50;
	
	BRect frame(200, 200, 700, 330);
	RPGWindow *window = new RPGWindow(frame, "Random Password Generator");
	window->Show();
}

// Show the about box
void RPGApp::AboutRequested()
{
	Alert("Random Password Generator 1.3.1\n\nby Wilhem Meignan\nw.m@wanadoo.fr",
			"Cool", B_INFO_ALERT);
}

void RPGApp::Alert(char *alert_text, char *btn_text, alert_type type)
{
	BAlert *alert = new BAlert("Alert", alert_text, btn_text, NULL, NULL,
			B_WIDTH_AS_USUAL, type);
	alert->SetShortcut(0, B_ESCAPE);
	alert->Go();
	// Alert types are:
	// B_EMPTY_ALERT
	// B_INFO_ALERT
	// B_IDEA_ALERT
	// B_WARNING_ALERT
	// B_STOP_ALERT
}

// Generate the passwords and store them to a file
void RPGApp::GeneratePasswords()
{
	BPath path("/boot/home");
	path.Append("Generated Passwords.txt");
	BFile outFile(path.Path(), B_WRITE_ONLY | B_CREATE_FILE | B_ERASE_FILE);
	if (outFile.InitCheck() != B_OK) {
		Alert("Could not create file !", "Why me ?", B_STOP_ALERT);
		return;
	}
	
	char *password = new char[fDigitNb+1];
	
	for (int32 i=0; i < fPassWdNb; i++) {
		GenerateAPassword(password, fDigitNb);
		outFile.Write(password, fDigitNb);
		outFile.Write("\n", 1);
	}
	
	delete [] password;
}

// Generate a password
void RPGApp::GenerateAPassword(char *password, int digit_nb)
{
	BString symbols;
	if (fUpperCase)	symbols<<"ABCDEFGHIJKLMNOPQRTSUVWXYZ";
	if (fLowerCase)	symbols<<"abcdefghijklmnopqrstuvwxyz";
	if (fNumbers)	symbols<<"0123456789";
	
	int32 symb_nb = symbols.Length();
	
	int32 i;
	for (i=0; i < digit_nb; i++)
		password[i] = symbols.String()[rand()%symb_nb];
	password[i] = 0;	// terminate the string
}
