#include <Alert.h>
#include <Application.h>
#include <File.h>
#include <stdlib.h>
#include <StorageKit.h>
#include <String.h>
#include <unistd.h>



class RPGApp : public BApplication {
public:
					RPGApp(const char *signature);
	
	virtual void	ReadyToRun();
	virtual void	AboutRequested();
	
	void			Alert(char *alert_text, char *btn_text, alert_type type);
	
	inline bool		UpperCase()				{return fUpperCase;}
	inline bool		LowerCase()				{return fLowerCase;}
	inline bool		Numbers()				{return fNumbers;}
	
	inline void		ChangeUpperCase()		{fUpperCase = !fUpperCase;}
	inline void		ChangeLowerCase()		{fLowerCase = !fLowerCase;}
	inline void		ChangeNumbers()			{fNumbers = !fNumbers;}
	
	inline int32	DigitNb()				{return fDigitNb;}
	inline int32	PassWdNb()				{return fPassWdNb;}
	
	inline void		SetDigitNb(int32 nb)	{fDigitNb = nb;}
	inline void		SetPassWdNb(int32 nb)	{fPassWdNb = nb;}
	
	void			GeneratePasswords();
	void			GenerateAPassword(char *pass, int digit_nb);
	
private:
	bool			fUpperCase;
	bool			fLowerCase;
	bool			fNumbers;
	
	int32			fDigitNb;
	int32			fPassWdNb;
};
